pcl::registration::CorrespondenceRejector Class Referenceabstract
Module registration

CorrespondenceRejector represents the base class for correspondence rejection methods More...

`#include <pcl/registration/correspondence_rejection.h>`

Inheritance diagram for pcl::registration::CorrespondenceRejector:

## Public Types

using | Ptr = shared_ptr< CorrespondenceRejector >
using | ConstPtr = shared_ptr< const CorrespondenceRejector >

## Public Member Functions

| CorrespondenceRejector ()
| Empty constructor. More...
virtual | ~CorrespondenceRejector ()
| Empty destructor. More...
virtual void | setInputCorrespondences (const CorrespondencesConstPtr &correspondences)
| Provide a pointer to the vector of the input correspondences. More...
CorrespondencesConstPtr | getInputCorrespondences ()
| Get a pointer to the vector of the input correspondences. More...
void | getCorrespondences (pcl::Correspondences &correspondences)
| Run correspondence rejection. More...
virtual void | getRemainingCorrespondences (const pcl::Correspondences &original_correspondences, pcl::Correspondences &remaining_correspondences)=0
| Get a list of valid correspondences after rejection from the original set of correspondences. More...
void | getRejectedQueryIndices (const pcl::Correspondences &correspondences, std::vector< int > &indices)
| Determine the indices of query points of correspondences that have been rejected, i.e., the difference between the input correspondences (set via setInputCorrespondences) and the given correspondence vector. More...
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | requiresSourcePoints () const
| See if this rejector requires source points. More...
virtual void | setSourcePoints (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the source cloud. More...
virtual bool | requiresSourceNormals () const
| See if this rejector requires source normals. More...
virtual void | setSourceNormals (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the source normals. More...
virtual bool | requiresTargetPoints () const
| See if this rejector requires a target cloud. More...
virtual void | setTargetPoints (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the target cloud. More...
virtual bool | requiresTargetNormals () const
| See if this rejector requires target normals. More...
virtual void | setTargetNormals (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the target normals. More...

## Protected Member Functions

virtual void | applyRejection (Correspondences &correspondences)=0
| Abstract rejection method. More...

## Protected Attributes

std::string | rejection_name_
| The name of the rejection method. More...
CorrespondencesConstPtr | input_correspondences_
| The input correspondences. More...

## Detailed Description

CorrespondenceRejector represents the base class for correspondence rejection methods

Author
  Dirk Holz

Definition at line 58 of file correspondence_rejection.h.

## Member Typedef Documentation

## ConstPtr

using pcl::registration::CorrespondenceRejector::ConstPtr = shared_ptr<const CorrespondenceRejector>

Definition at line 62 of file correspondence_rejection.h.

## Ptr

using pcl::registration::CorrespondenceRejector::Ptr = shared_ptr<CorrespondenceRejector>

Definition at line 61 of file correspondence_rejection.h.

## Constructor & Destructor Documentation

## CorrespondenceRejector()

pcl::registration::CorrespondenceRejector::CorrespondenceRejector | ( |  | ) |

inline

Empty constructor.

Definition at line 65 of file correspondence_rejection.h.

## ~CorrespondenceRejector()

virtual pcl::registration::CorrespondenceRejector::~CorrespondenceRejector | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 69 of file correspondence_rejection.h.

## Member Function Documentation

## applyRejection()

virtual void pcl::registration::CorrespondenceRejector::applyRejection | ( | Correspondences & | correspondences | ) |

protected pure virtual

Abstract rejection method.

Implemented in pcl::registration::CorrespondenceRejectorSurfaceNormal, pcl::registration::CorrespondenceRejectorPoly< SourceT, TargetT >, pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >, pcl::registration::CorrespondenceRejectorVarTrimmed, pcl::registration::CorrespondenceRejectorDistance, pcl::registration::CorrespondenceRejectorMedianDistance, pcl::registration::CorrespondenceRejectorFeatures, pcl::registration::CorrespondenceRejectionOrganizedBoundary, pcl::registration::CorrespondenceRejectorTrimmed, pcl::registration::CorrespondenceRejectorOneToOne, and pcl::registration::CorrespondenceRejectorSampleConsensus2D< PointT >.

Referenced by getCorrespondences().

## getClassName()

const std::string& pcl::registration::CorrespondenceRejector::getClassName | ( |  | ) | const

inline

Get a string representation of the name of this class.

Definition at line 132 of file correspondence_rejection.h.

References rejection_name_.

Referenced by getRejectedQueryIndices(), setSourceNormals(), setSourcePoints(), setTargetNormals(), and setTargetPoints().

## getCorrespondences()

void pcl::registration::CorrespondenceRejector::getCorrespondences | ( | pcl::Correspondences & | correspondences | ) |

inline

Run correspondence rejection.

Parameters

  [out] | correspondences | Vector of correspondences that have not been rejected.

Definition at line 90 of file correspondence_rejection.h.

References applyRejection(), and input_correspondences_.

## getInputCorrespondences()

CorrespondencesConstPtr pcl::registration::CorrespondenceRejector::getInputCorrespondences | ( |  | ) |

inline

Get a pointer to the vector of the input correspondences.

Returns
  correspondences the const boost shared pointer to a correspondence vector

Definition at line 84 of file correspondence_rejection.h.

References input_correspondences_.

## getRejectedQueryIndices()

void pcl::registration::CorrespondenceRejector::getRejectedQueryIndices | ( | const pcl::Correspondences & | correspondences,
|  | std::vector< int > & | indices
| ) |  |

inline

Determine the indices of query points of correspondences that have been rejected, i.e., the difference between the input correspondences (set via setInputCorrespondences) and the given correspondence vector.

Parameters

  [in] | correspondences | Vector of correspondences after rejection
  [out] | indices | Vector of query point indices of those correspondences that have been rejected.

Definition at line 118 of file correspondence_rejection.h.

References getClassName(), pcl::getRejectedQueryIndices(), and input_correspondences_.

## getRemainingCorrespondences()

virtual void pcl::registration::CorrespondenceRejector::getRemainingCorrespondences | ( | const pcl::Correspondences & | original_correspondences,
|  | pcl::Correspondences & | remaining_correspondences
| ) |  |

inline pure virtual

Get a list of valid correspondences after rejection from the original set of correspondences.

Pure virtual. Compared to getCorrespondences this function is stateless, i.e., input correspondences do not need to be provided beforehand, but are directly provided in the function call.

Parameters

  [in] | original_correspondences | the set of initial correspondences given
  [out] | remaining_correspondences | the resultant filtered set of remaining correspondences

Implemented in pcl::registration::CorrespondenceRejectorTrimmed, pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >, pcl::registration::CorrespondenceRejectorPoly< SourceT, TargetT >, pcl::registration::CorrespondenceRejectorVarTrimmed, pcl::registration::CorrespondenceRejectorFeatures, pcl::registration::CorrespondenceRejectorDistance, pcl::registration::CorrespondenceRejectorMedianDistance, pcl::registration::CorrespondenceRejectorSurfaceNormal, pcl::registration::CorrespondenceRejectorOneToOne, pcl::registration::CorrespondenceRejectionOrganizedBoundary, and pcl::registration::CorrespondenceRejectorSampleConsensus2D< PointT >.

## requiresSourceNormals()

virtual bool pcl::registration::CorrespondenceRejector::requiresSourceNormals | ( |  | ) | const

inline virtual

See if this rejector requires source normals.

Reimplemented in pcl::registration::CorrespondenceRejectorSurfaceNormal.

Definition at line 149 of file correspondence_rejection.h.

## requiresSourcePoints()

virtual bool pcl::registration::CorrespondenceRejector::requiresSourcePoints | ( |  | ) | const

inline virtual

See if this rejector requires source points.

Reimplemented in pcl::registration::CorrespondenceRejectorSurfaceNormal, pcl::registration::CorrespondenceRejectorDistance, pcl::registration::CorrespondenceRejectorVarTrimmed, pcl::registration::CorrespondenceRejectorPoly< SourceT, TargetT >, pcl::registration::CorrespondenceRejectorMedianDistance, pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >, and pcl::registration::CorrespondenceRejectionOrganizedBoundary.

Definition at line 137 of file correspondence_rejection.h.

## requiresTargetNormals()

virtual bool pcl::registration::CorrespondenceRejector::requiresTargetNormals | ( |  | ) | const

inline virtual

See if this rejector requires target normals.

Reimplemented in pcl::registration::CorrespondenceRejectorSurfaceNormal.

Definition at line 172 of file correspondence_rejection.h.

## requiresTargetPoints()

virtual bool pcl::registration::CorrespondenceRejector::requiresTargetPoints | ( |  | ) | const

inline virtual

See if this rejector requires a target cloud.

Reimplemented in pcl::registration::CorrespondenceRejectorSurfaceNormal, pcl::registration::CorrespondenceRejectorDistance, pcl::registration::CorrespondenceRejectorVarTrimmed, pcl::registration::CorrespondenceRejectorPoly< SourceT, TargetT >, pcl::registration::CorrespondenceRejectorMedianDistance, pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >, and pcl::registration::CorrespondenceRejectionOrganizedBoundary.

Definition at line 160 of file correspondence_rejection.h.

## setInputCorrespondences()

virtual void pcl::registration::CorrespondenceRejector::setInputCorrespondences | ( | const CorrespondencesConstPtr & | correspondences | ) |

inline virtual

Provide a pointer to the vector of the input correspondences.

Parameters

  [in] | correspondences | the const boost shared pointer to a correspondence vector

Definition at line 75 of file correspondence_rejection.h.

References input_correspondences_.

## setSourceNormals()

virtual void pcl::registration::CorrespondenceRejector::setSourceNormals | ( | pcl::PCLPointCloud2::ConstPtr |  | ) |

inline virtual

Abstract method for setting the source normals.

Reimplemented in pcl::registration::CorrespondenceRejectorSurfaceNormal.

Definition at line 154 of file correspondence_rejection.h.

References getClassName().

## setSourcePoints()

virtual void pcl::registration::CorrespondenceRejector::setSourcePoints | ( | pcl::PCLPointCloud2::ConstPtr |  | ) |

inline virtual

Abstract method for setting the source cloud.

Reimplemented in pcl::registration::CorrespondenceRejectorSurfaceNormal, pcl::registration::CorrespondenceRejectorDistance, pcl::registration::CorrespondenceRejectorVarTrimmed, pcl::registration::CorrespondenceRejectorPoly< SourceT, TargetT >, pcl::registration::CorrespondenceRejectorMedianDistance, pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >, and pcl::registration::CorrespondenceRejectionOrganizedBoundary.

Definition at line 142 of file correspondence_rejection.h.

References getClassName().

## setTargetNormals()

virtual void pcl::registration::CorrespondenceRejector::setTargetNormals | ( | pcl::PCLPointCloud2::ConstPtr |  | ) |

inline virtual

Abstract method for setting the target normals.

Reimplemented in pcl::registration::CorrespondenceRejectorSurfaceNormal.

Definition at line 177 of file correspondence_rejection.h.

References getClassName().

## setTargetPoints()

virtual void pcl::registration::CorrespondenceRejector::setTargetPoints | ( | pcl::PCLPointCloud2::ConstPtr |  | ) |

inline virtual

Abstract method for setting the target cloud.

Reimplemented in pcl::registration::CorrespondenceRejectorSurfaceNormal, pcl::registration::CorrespondenceRejectorDistance, pcl::registration::CorrespondenceRejectorVarTrimmed, pcl::registration::CorrespondenceRejectorPoly< SourceT, TargetT >, pcl::registration::CorrespondenceRejectorMedianDistance, pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >, and pcl::registration::CorrespondenceRejectionOrganizedBoundary.

Definition at line 165 of file correspondence_rejection.h.

References getClassName().

## Member Data Documentation

## input_correspondences_

CorrespondencesConstPtr pcl::registration::CorrespondenceRejector::input_correspondences_

protected

The input correspondences.

Definition at line 188 of file correspondence_rejection.h.

Referenced by pcl::registration::CorrespondenceRejectorSampleConsensus2D< PointT >::applyRejection(), pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >::applyRejection(), getCorrespondences(), getInputCorrespondences(), getRejectedQueryIndices(), and setInputCorrespondences().

## rejection_name_

std::string pcl::registration::CorrespondenceRejector::rejection_name_

protected

The name of the rejection method.

Definition at line 185 of file correspondence_rejection.h.

Referenced by pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >::CorrespondenceRejectorSampleConsensus(), pcl::registration::CorrespondenceRejectorSampleConsensus2D< PointT >::CorrespondenceRejectorSampleConsensus2D(), and getClassName().

The documentation for this class was generated from the following file:

- pcl/registration/correspondence_rejection.h